/*
 * This file is part of the Owl Positioning System (OwlPS) project.
 * It is subject to the copyright notice and license terms in the
 * COPYRIGHT.t2t file found in the top-level directory of this
 * distribution and at
 *   https://code.lm7.fr/mcy/owlps/src/master/COPYRIGHT.t2t
 * No part of the OwlPS Project, including this file, may be copied,
 * modified, propagated, or distributed except according to the terms
 * contained in the COPYRIGHT.t2t file; the COPYRIGHT.t2t file must be
 * distributed along with this file, either separately or by replacing
 * this notice by the COPYRIGHT.t2t file's contents.
 */


#ifndef _OWLPS_POSITIONING_INPUT_HH_
#define _OWLPS_POSITIONING_INPUT_HH_

class InputMedium ;
class InputLogMedium ;
class Request ;

#include <vector>

/// Handles the inputs
class Input
{
protected:
  InputMedium *medium ; ///< Input medium used
  /// List of input log media used
  std::vector<InputLogMedium*> log_media ;

  void initialise_input_medium(void) ;
  void initialise_log_media(void) ;
  void initialise_log_csv(void) ;
  void log_current_request(void) const ;

public:
  Input(void) ;

  ~Input(void) ;

  /** @name Operations */
  //@{
  const Request& get_next_request(void) const ;
  bool eof(void) const ;
  //@}
} ;

#endif // _OWLPS_POSITIONING_INPUT_HH_
